package de.gjlay.ebook;

import java.io.*;
import java.util.*;

import de.gjlay.tools.*;

public class Milestones
{
	public static final String USAGE =
	"Usage:\n"
	+"Milestones infile \n"
	;

	public static void main (String[] args)
		throws Exception
		{
			try
			{
				int idx = 0;
				Reader reader;

				if (args.length >= 1)
					reader = new FileReader (args[0]);
				else
					reader = new FileReader ("d:/avr/ebook-2313/data/input.txt");

				String text = FileTools.getString (reader, "\n");

				reader.close();

				int len = text.length();

				out ("// Len="+len);

				int pos = -1;

				while (true)
				{
 					pos = 1+text.indexOf ("_", pos+1);
					if (0 == pos)
						break;

					int pos2 = text.indexOf ("\n", pos);
					String kap = text.substring (pos, pos2);

					if (kap.endsWith (" 1"))
					{
						kap = text.substring (pos, pos2-2);

						if (++idx == 1)
						{
							out ("const unsigned long PGM_index[] PROGMEM = ");
							out ("{");
						}
						String hex = Integer.toHexString (pos);
						hex = "000000".substring (0, 6-hex.length()) + hex;
						out ("   0x"
								+ hex
								+ ", // ["+(idx-1) + "] "
								+ kap);
					}
				}
				out ("   0x"+Integer.toHexString (len)
						+" // first 0xff (end of eBook)");

				out ("};");
			}
			catch (Exception ex)
			{
				out (USAGE);
				throw (ex);
			}
		}

	static void out (String msg)
		{
			System.out.println (msg);
		}
}
